package com.cxytiandi.apollo;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import com.ctrip.framework.apollo.ConfigFile;
import com.ctrip.framework.apollo.ConfigService;
import com.ctrip.framework.apollo.core.enums.ConfigFileFormat;
import com.ctrip.framework.apollo.model.ConfigChange;
import com.ctrip.framework.apollo.model.ConfigChangeEvent;
import com.ctrip.framework.apollo.spring.annotation.ApolloConfigChangeListener;
import com.ctrip.framework.apollo.spring.annotation.ApolloJsonValue;

@RestController
public class TestController {

	@Value("${username}")
	private String name;

	@ApolloJsonValue("${user}")
	private User user;
	
	@GetMapping("/test2")
	public User test2() {
		return user;
	}
	@GetMapping("/test")
	public String test() {
		ConfigFile configFile = ConfigService.getConfigFile("hh", ConfigFileFormat.JSON);
		System.err.println(configFile.getContent());
		return name;
	}

	@ApolloConfigChangeListener("application")
	private void anotherOnChange(ConfigChangeEvent changeEvent) {
		System.out.println("Changes for namespace " + changeEvent.getNamespace());
        for (String key : changeEvent.changedKeys()) {
            ConfigChange change = changeEvent.getChange(key);
            System.out.println(String.format("Found change - key: %s, oldValue: %s, newValue: %s, changeType: %s", change.getPropertyName(), change.getOldValue(), change.getNewValue(), change.getChangeType()));
        }
	}
}
